* a set of named constants to simplify BASIC programming
* BLACK (0), BLUE(1), RED(2)...WHITE (7)
* TRUE(1), FALSE(0), ON_(1),OFF(0) (note ON_ because ON already exists)
* YES(1), NO(0)
* ZERO, ONE, TWO...NINE

bv_rip          equ     $58
bp_init         equ     $110
bp_let          equ     $120
bv_chrix        equ     $11A
err_bp          equ     -15

* first link extensions to SuperBASIC using bp.init vectored routine
                move.w    bp_init,a0        ;initialise new extensions
                lea       exts,a1           ;where is the table?
                jsr       (a0)              ;call the vectored routine
                rts                         ;back to basic

* this table defines the 'extensions'
exts    dc.w    0,0             ;no procedures
        dc.w    24              ;24 functions
        dc.w    zero-*
        dc.b    5,'BLACK'
        dc.w    one-*
        dc.b    4,'BLUE',0
        dc.w    two-*
        dc.b    3,'RED'
        dc.w    three-*
        dc.b    7,'MAGENTA'
        dc.w    four-*
        dc.b    5,'GREEN'
        dc.w    five-*
        dc.b    4,'CYAN',0
        dc.w    six-*
        dc.b    6,'YELLOW',0
        dc.w    seven-*
        dc.b    5,'WHITE'
        dc.w    one-*
        dc.b    4,'TRUE',0
        dc.w    zero-*
        dc.b    5,'FALSE'
        dc.w    one-*
        dc.b    3,'ON_'
        dc.w    zero-*
        dc.b    3,'OFF'
        dc.w    one-*
        dc.b    3,'YES'
        dc.w    zero-*
        dc.b    2,'NO',0
        dc.w    zero-*
        dc.b    4,'ZERO',0
        dc.w    one-*
        dc.b    3,'ONE'
        dc.w    two-*
        dc.b    3,'TWO'
        dc.w    three-*
        dc.b    5,'THREE'
        dc.w    four-*
        dc.b    4,'FOUR',0
        dc.w    five-*
        dc.b    4,'FIVE',0
        dc.w    six-*
        dc.b    3,'SIX'
        dc.w    seven-*
        dc.b    5,'SEVEN'
        dc.w    eight-*
        dc.b    5,'EIGHT'
        dc.w    nine-*
        dc.b    4,'NINE',0
        dc.w    0               ;no more functions

zero    moveq   #0,d7
        bra.s   retval
one     moveq   #1,d7
        bra.s   retval
two     moveq   #2,d7
        bra.s   retval
three   moveq   #3,d7
        bra.s   retval
four    moveq   #4,d7
        bra.s   retval
five    moveq   #5,d7
        bra.s   retval
six     moveq   #6,d7
        bra.s   retval
seven   moveq   #7,d7
        bra.s   retval
eight   moveq   #8,d7
        bra.s   retval
nine    moveq   #9,d7

retval  cmp.l     a3,a5          ;shouldn't be any parameters
        bne.s     oops           ;bad parameter!

        moveq     #2,d1          ;reserve 2 bytes on RI stack
        move.w    bv_chrix,a2    ;vector details
        jsr       (a2)

        move.l    bv_rip(a6),a1  ;recover RI stack pointer
        sub.l     #2,a1          ;2 bytes to return
        move.l    a1,bv_rip(a6)  ;save new RI stack ptr value

        move.w    d7,0(a6,a1.l)  ;place return value on stack
        moveq     #3,d4          ;return type 'word'

        moveq     #0,d0          ;ensure no error message
        rts                      ;back to BASIC

* The routines do not expect any parameters, will give err.bp if any supplied
oops    moveq     #err_bp,d0     ;code for 'bad parameter' error
        rts                      ;back to BASIC
